import os
import sys

root = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))))
sys.path.append(root)

# ----------------------------------------------------------------------------

# PLEASE DO NOT EDIT THIS FILE, IT IS GENERATED AND WILL BE OVERWRITTEN:
# https://github.com/ccxt/ccxt/blob/master/CONTRIBUTING.md#how-to-contribute-code

# ----------------------------------------------------------------------------
# -*- coding: utf-8 -*-

from ccxt.test.base import test_ohlcv  # noqa E402
from ccxt.test.base import test_shared_methods  # noqa E402

async def test_watch_ohlcv(exchange, skipped_properties, symbol):
    method = 'watchOHLCV'
    now = exchange.milliseconds()
    ends = now + 15000
    timeframe_keys = list(exchange.timeframes.keys())
    assert len(timeframe_keys), exchange.id + ' ' + method + ' - no timeframes found'
    # prefer 1m timeframe if available, otherwise return the first one
    chosen_timeframe_key = '1m'
    if not exchange.in_array(chosen_timeframe_key, timeframe_keys):
        chosen_timeframe_key = timeframe_keys[0]
    limit = 10
    duration = exchange.parse_timeframe(chosen_timeframe_key)
    since = exchange.milliseconds() - duration * limit * 1000 - 1000
    while now < ends:
        response = None
        try:
            response = await exchange.watch_ohlcv(symbol, chosen_timeframe_key, since, limit)
        except Exception as e:
            if not test_shared_methods.is_temporary_failure(e):
                raise e
            now = exchange.milliseconds()
            continue
        assert isinstance(response, list), exchange.id + ' ' + method + ' ' + symbol + ' must return an array. ' + exchange.json(response)
        now = exchange.milliseconds()
        for i in range(0, len(response)):
            test_ohlcv(exchange, skipped_properties, method, response[i], symbol, now)
